/* @pjs pauseOnBlur="true"; */

// Diffusion
// par J.Roussel <http://perso.ensc-rennes.fr/jimmy.roussel>
// Simule une diffusion brownienne 
//on représente num2 marches aléatoires de particules initialement au centre de
//l'écran ; 

// 6 Octobre 2006
//MAJ 5 Mars 2012

int  NbPas;
int range = 5;//longueur de chaque pas aléatoire
int num2 = 5000;//Nombre de particules browniennes

float[] ax = new float[num2];//abcisse de la particule j, 
float[]ay = new float[num2];//ordonnée de la particule j,
boolean playing = false;

void setup() 
{
  size(200, 200);
  frameRate(20);
  ellipseMode(CENTER);
  text("",0,0);  // force Processing to load a font
  textSize(20);	// set the font size to something big
  //smooth(); 
  noStroke();
  //initialisation
  initialisation();
}

void draw() {
  if (playing) {
    for (int j=0; j<num2; j++) {
      ax[j] += random(-range, range);
      ay[j] += random(-range, range);
      // Conditions de bord périodiques    
      ax[j] =(ax[j]+width)%width;
      ay[j] = (ay[j]+height)%height;
    }
    fill(255);
    for (int j=0; j<num2; j++) {
      ellipse(ax[j], ay[j], 2, 2);
    }
    fill(0, 0, 0, 50);
    rect(0, 0, width, height);
  }
}

/*** Start playback */
void play() {
  playing = true;
  loop();
} 
/*** Pause playback */
void stop() {
  playing = false;
  initialisation();
  noLoop();
}


void mouseClicked() {
  if (!playing) { 
    play();
  }
  else { 
    stop();
  }
}

void initialisation() {
  NbPas=0;
  fill(0, 0, 0, 255);
  rect(0, 0, width, height);
  for (int j=0;j<num2; j++) {
    ax[j] = width/2;
    ay[j] = height/2;
  }
  fill(255);
  String pausetext = "Click to play/stop";
  float twidth = textWidth(pausetext);
  text(pausetext, (width-twidth)/2,height/2);
}


