
/* @pjs pauseOnBlur="true"; */

// Diffusion2
// par J.Roussel <http://perso.ensc-rennes.fr>
// Simule une diffusion brownienne et met en évidence la loi de diffusion 
// Début : 6 Octobre 2006
// Fev. 2012 : modification pour une mise en ligne via processing.js

int range = 5;//longueur de chaque pas aléatoire
int NbPas;//nombre de pas
int num2 = 1000;//Nombre de particules browniennes
float Rcarre;//Somme quadratique
int Rcarremoy;//Distance quadratique moyenne
int pRcarremoy=0;//Distance quadratique moyenne précédente
int hauteur=220;//hauteur de l'écran
int Nmax=1000; //nombre maximum de pas après quoi la simu s'arrête.
int Rcarremax;

float facteurX;
float facteurY;
float K;
float[]ax = new float[num2];//abcisse de la particule j, 
float[]ay = new float[num2]; 

boolean playing = false;

void setup() 
{
  size(400, 220);
  ellipseMode(CENTER); 
  text("",0,0);  // force Processing to load a font
  textSize(10);	// set the font size to something big
  initialisation();
  frameRate(25);
  Rcarremax=int(200*200/6);
  facteurX=190./Nmax;
  facteurY=190./(1.1*Rcarremax);
  stroke(0);
  fill(0);
  rect(0,0,200,200);
}

void draw() {
  if(playing) {
   Rcarre=0;  //intialisation des distances quadratiques
   for(int j=0; j<num2; j++) {
    ax[j] += random(-range, range);
    ay[j] += random(-range, range);
    // Conditions de bord p√©riodiques    
    ax[j] =(ax[j]+200)%200;
    ay[j] = (ay[j]+200)%200;
    Rcarre += sq(ax[j]-100)+sq(ay[j]-100);
      }
    Rcarremoy=int(Rcarre/num2);
    stroke(255,0,0);
    point(210+facteurX*(NbPas),(190-facteurY*Rcarremoy));
    noStroke();
    fill(0,0,0,100);
    rect(0,0,202,202);    
    for(int j=0; j<num2; j++) {
      fill(255);
      ellipse(ax[j], ay[j],2,2);    
     }
     // Ecriture de la distance quadratique et de N.
     noStroke();;fill(255);
     rect(0,200,400,20);
     fill(0);
     text("<R^2>=",5,212);
     text(Rcarremoy,50,212);
     NbPas+=1;
     text("N = "+NbPas,100,212);
     // dessin des courbes th√©oriques
     if (NbPas > Nmax) 
      {K=0.666666*sq(range);
      stroke(0);
      line(210,190,400,(190-K*facteurY*Nmax));
      line(210,(190-facteurY*Rcarremax),400,(190-facteurY*Rcarremax));
      text("loi de diffusion",250,160);
      text("effets de bord",300,12);
      noLoop();}
  }
}
//fonction tra√ßant deux axes
void axes(int x0, int y0, int xmin, int xmax, int ymin, int ymax ,int couleur,int fleche){
  stroke(couleur);
  line(xmin,y0,xmax,y0);
  line(x0,ymin,x0,ymax);
  fill(couleur);
  triangle(xmax,y0,xmax-fleche,y0+fleche,xmax-fleche,y0-fleche);
  triangle(x0,ymax,x0+fleche,ymax+fleche,x0-fleche,ymax+fleche); 
  }
/*** Start playback */
void play() {
	playing = true;
	loop();
} 
/*** Pause playback */
void stop() {
  initialisation();
  playing = false;
  noLoop(); 
}


void mouseClicked() {
	if(!playing) { play(); }
	else { stop(); }}

void initialisation(){
  noStroke();
  NbPas=0;Rcarre=0;
  fill(0);
  rect(0,0,202,202); 
  fill(235);
  rect(202,0,200,200);
  axes(210, 190, 200, 400, 200, 0, 50, 3);
   text("N",380,185);
   text("R^2",215,12);
   noStroke();
   fill(255);
   rect(0,200,400,20);
   for(int j=0;j<num2; j++) {
      ax[j] =100;
      ay[j] =100;    
  }
}